<template>
  <nav class="navbar navbar-expand-lg navbar-dark bg-primary">
    <a class="navbar-brand" href="/">
      <svg style="width:30px;height:30px" viewBox="0 0 30 30">
        <path
          fill="#fff"
          d="M12.74,5.47C15.1,6.5 16.35,9.03 15.92,11.46C17.19,12.56 18,14.19 18,16V16.17C18.31,16.06 18.65,16 19,16A3,3 0 0,1 22,19A3,3 0 0,1 19,22H6A4,4 0 0,1 2,18A4,4 0 0,1 6,14H6.27C5,12.45 4.6,10.24 5.5,8.26C6.72,5.5 9.97,4.24 12.74,5.47M11.93,7.3C10.16,6.5 8.09,7.31 7.31,9.07C6.85,10.09 6.93,11.22 7.41,12.13C8.5,10.83 10.16,10 12,10C12.7,10 13.38,10.12 14,10.34C13.94,9.06 13.18,7.86 11.93,7.3M13.55,3.64C13,3.4 12.45,3.23 11.88,3.12L14.37,1.82L15.27,4.71C14.76,4.29 14.19,3.93 13.55,3.64M6.09,4.44C5.6,4.79 5.17,5.19 4.8,5.63L4.91,2.82L7.87,3.5C7.25,3.71 6.65,4.03 6.09,4.44M18,9.71C17.91,9.12 17.78,8.55 17.59,8L19.97,9.5L17.92,11.73C18.03,11.08 18.05,10.4 18,9.71M3.04,11.3C3.11,11.9 3.24,12.47 3.43,13L1.06,11.5L3.1,9.28C3,9.93 2.97,10.61 3.04,11.3M19,18H16V16A4,4 0 0,0 12,12A4,4 0 0,0 8,16H6A2,2 0 0,0 4,18A2,2 0 0,0 6,20H19A1,1 0 0,0 20,19A1,1 0 0,0 19,18Z"
        />
      </svg>
      {{ appName }}
    </a>
    <button
      class="navbar-toggler"
      type="button"
      data-toggle="collapse"
      data-target="#navbarNav"
      aria-controls="navbarNav"
      aria-expanded="false"
      aria-label="Toggle navigation"
    >
      <span class="navbar-toggler-icon"></span>
    </button>
    <div class="collapse navbar-collapse" id="navbarNav">
      <ul class="navbar-nav mr-auto">
        <li class="nav-item">
          <router-link to="/" class="nav-link">Home</router-link>
        </li>
        <li class="nav-item">
          <router-link to="/data" class="nav-link">Data statistics</router-link>
        </li>
        <li class="nav-item">
          <router-link to="/map" class="nav-link">Map</router-link>
        </li>
        <li class="nav-item" v-if="isAdmin()">
          <router-link to="/admin" class="nav-link">Admin panel</router-link>
        </li>
      </ul>
      <span class="navbar-text">
        <!-- logout placeholder -->
        <!-- <router-link to="/login" class="nav-link">Login</router-link> -->
        <a class="logout-link" v-on:click="logout()">Logout</a>
      </span>
    </div>
  </nav>
</template>
-

<script>
function parseJwt(token) {
  var base64Url = token.split(".")[1];
  var base64 = base64Url.replace(/-/g, "+").replace(/_/g, "/");
  var jsonPayload = decodeURIComponent(
    atob(base64)
      .split("")
      .map(function(c) {
        return "%" + ("00" + c.charCodeAt(0).toString(16)).slice(-2);
      })
      .join("")
  );
  return JSON.parse(jsonPayload);
}
import dictionary from "../../shared/dictionary";
import { mapState, mapActions } from "vuex";

export default {
  name: "Navbar",
  data() {
    return {
      user: JSON.parse(localStorage.getItem("user")),

      appName: dictionary["appName"]
    };
  },
  methods: {
    ...mapActions("account", ["logout"]),
    isAdmin() {
      let claims = parseJwt(this.user.token);
      console.log(claims);
      return claims.role === "Admin";
    }
  }
};
</script>

<style>
.logout-link {
  cursor: pointer;
}

.router-link-exact-active {
  color: #fff !important;
}
</style>
